#game.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import pygame
import math
import display
import level
import enemy
import g
import sys

global clock
clock = pygame.time.Clock()

global loc

def move(x, y):
    global loc
    global cur_level
    loc, x, y = g.wallcheck(loc, x, y, cur_level)

    #actually move
    loc = (loc[0]+x, loc[1]+y)

global z
global health
global cur_level
global lookdir

def zoom(tmp_zoom):
    global z
    z += tmp_zoom
    if z < 7: z = 7
    if z > 30: z = 30

def main():
    global loc
    global lookdir
    global z
    global health
    global cur_level
    global nosound
    global difficulty
    radianpldir = 0
    nosound = False
    cur_level = 0
    video_flags = pygame.OPENGL|pygame.DOUBLEBUF
    z = 15.0
    lookdir = 0.0
    health = 200
    clipping_qual = 20
    flash_flip = False

    pygame.init()
    surface = pygame.display.set_mode((640,480), video_flags)

    display.setup_opengl((640,480))
    #pygame.event.set_grab(1)
    pygame.mouse.set_visible(0)

    try:
        import psyco
        psyco.full()
    except ImportError:
        print "Psyco not found. If performance is too slow, install Psyco"
    try:
        pygame.mixer.init()
        gulpsound = pygame.mixer.Sound("../images/gulp.wav")
    except:
        print "Sound startup failed. You will hear no sound."
        nosound = True

    display.load_level(cur_level)
    loc = (level.maps[0].startpos[0]*10.0+5.0, level.maps[0].startpos[1]*10.0+5.0)
    quit_game = False
    i = 0
    while 1:
        if quit_game: break
        time = clock.tick(80)
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                quit_game = True
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    quit_game = True
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 4:
                    quit_game = zoom(-0.6)
                if event.button == 5:
                    quit_game = zoom(0.6)
        temp = pygame.key.get_pressed()
        x = y = 0
        pldir = [0, 0]
        if temp[pygame.K_UP]:
            y = -0.06*time
            pldir[1] = 1
        if temp[pygame.K_DOWN]:
            y = 0.06*time
            pldir[1] = -1
        if temp[pygame.K_LEFT]:
            x = -0.06*time
            pldir[0] = -1
        if temp[pygame.K_RIGHT]:
            x = 0.06*time
            pldir[0] = 1

        if pldir == [1, 0]: radianpldir = 0
        elif pldir == [1, 1]: radianpldir = math.pi/4.0
        elif pldir == [1, -1]: radianpldir = 7.0*math.pi/4.0
        elif pldir == [-1, 0]: radianpldir = math.pi
        elif pldir == [-1, 1]: radianpldir = 3.0*math.pi/4.0
        elif pldir == [-1, -1]: radianpldir = 5.0*math.pi/4.0
        elif pldir == [0, 1]: radianpldir = math.pi/2.0
        elif pldir == [0, -1]: radianpldir = 3.0*math.pi/2.0
        if temp[pygame.K_PAGEUP]: zoom(-0.3)
        if temp[pygame.K_PAGEDOWN]: zoom(0.3)
        if temp[pygame.K_SPACE]:
            if g.kill(0, loc, cur_level):
                if not nosound: gulpsound.play()
        if temp[pygame.K_LSHIFT]:
            if g.kill(1, loc, cur_level):
                if not nosound: gulpsound.play()
        if temp[pygame.K_z]: lookdir = (lookdir-0.006*time) % 6.283185307
        if temp[pygame.K_x]: lookdir = (lookdir+0.006*time) % 6.283185307
        move(x, y)
        if len(level.maps[cur_level].enemy_list) == 0:
            cur_level += 1
            display.load_level(cur_level)
            loc = (level.maps[cur_level].startpos[0]*10.0+5.0,
                    level.maps[cur_level].startpos[1]*10.0+5.0)
            level.enemy.blood_array = []
            health = 200
        flash = False
        flash_flip = not flash_flip
        for enemy in level.maps[cur_level].enemy_list:
            enemy.move(time, cur_level)
            if g.dist(loc, enemy.loc, enemy.sightrange):
                if g.check_sight(loc, enemy.loc, cur_level):
                    tmp = g.check_sightdir(loc, enemy)
                    if tmp > 0:
                        flash = flash_flip
                        health -= tmp * difficulty
        for i in range(len(level.enemy.blood_array)-1, -1, -1):
            level.enemy.blood_array[i].livetime -= time
            if level.enemy.blood_array[i].livetime < 0:
                level.enemy.blood_array.pop(i)
        tempfps=display.draw_frame(loc, z, lookdir, cur_level, health, flash, radianpldir)
        pygame.draw.rect(surface, (120, 0, 0, 99), (5, 400, 20, 70), 1)
        if health <= 0:
            level.maps[cur_level] = level.map_class(level.map_list[cur_level])
            display.load_level(cur_level)
            loc = (level.maps[cur_level].startpos[0]*10.0+5.0,
                    level.maps[cur_level].startpos[1]*10.0+5.0)
            level.enemy.blood_array = []
            health = 200

        i += 1
        if i % 100 == 0:
            print tempfps, clock.get_fps()
            i = 0
        pygame.display.flip()


global difficulty
difficulty = 2

if len(sys.argv) > 1:
    difficulty = int(sys.argv[1])

main()
